﻿using GrapeCity.ActiveReports;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace RunTime_RDL_Report_in_Web.Reports
{
    public class ReportDefinition 
    {
        public PageReport rdlReport = new PageReport();
        public ReportDefinition()
        {
            rdlReport.Report.PaperOrientation = GrapeCity.ActiveReports.PageReportModel.PaperOrientation.Landscape;
            rdlReport.Report.PageHeight = "8in";
            rdlReport.Report.PageWidth = "11in";

            //Page Header
            GrapeCity.ActiveReports.PageReportModel.PageHeaderFooter headers = new GrapeCity.ActiveReports.PageReportModel.PageHeaderFooter();
            rdlReport.Report.PageHeader = headers;
            headers.Height = ".5in";
            headers.PrintOnFirstPage = true;
            headers.PrintOnLastPage = true;

            //Page Footer
            GrapeCity.ActiveReports.PageReportModel.PageHeaderFooter footer = new GrapeCity.ActiveReports.PageReportModel.PageHeaderFooter();
            rdlReport.Report.PageFooter = footer;
            footer.Height = ".5in";
            footer.PrintOnFirstPage = true;
            footer.PrintOnLastPage = true;

            GrapeCity.ActiveReports.PageReportModel.TextBox pageNumber = new GrapeCity.ActiveReports.PageReportModel.TextBox();
            pageNumber.Name = "pNumber";
            pageNumber.Height = ".5cm";
            pageNumber.Width = "1cm";
            pageNumber.Left = "25cm";
            pageNumber.Top = "0cm";
            pageNumber.Value = "=Globals!PageNumber";
            footer.ReportItems.Add(pageNumber);

            GrapeCity.ActiveReports.PageReportModel.TextBox reportTitle = new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "Report Title",
                Value = "=\"List of Customers in \" & Parameters!selectedCountry.Value",
                Height = "0.5in",
                Width = "5in",
                Top = "0in",
                Left = "0.5in",
                Style = { TextAlign = "Left", FontSize = "18pt", FontWeight = "Bold" }
            };

            GrapeCity.ActiveReports.PageReportModel.Table customersTable = new GrapeCity.ActiveReports.PageReportModel.Table()
            {
                Name = "CustomersTable",
                Top = "0.75in",
                Left = "0.5in",
                DataSetName = "MyDataSet"
            };

            #region Table Headers

            //Creating table header
            customersTable.Header = new GrapeCity.ActiveReports.PageReportModel.Header();
            customersTable.Header.TableRows.Add(new GrapeCity.ActiveReports.PageReportModel.TableRow() { Height = ".4in" });
            var customerHeader = customersTable.Header.TableRows[0].TableCells;

            //First cell in the table header
            customerHeader.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerHeader[0].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "Company Name",
                Value = "Company Name",                
                Style = { BorderStyle = { Bottom = "Solid" },
                    VerticalAlign = "Middle",
                    PaddingLeft="3pt",
                    TextAlign = "Left",
                    BackgroundColor = "WhiteSmoke",
                    FontWeight = "Bold" }
            });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "2.35in" });

            //Second cell in the table header
            customerHeader.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerHeader[1].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "Contact Name",
                Value = "Contact Name",
                Style = { BorderStyle = { Bottom = "Solid" },
                    VerticalAlign = "Middle",
                    TextAlign = "Left",
                    BackgroundColor = "WhiteSmoke",
                    FontWeight = "Bold" }
            });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.75in" });

            customerHeader.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerHeader[2].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "Address", Value = "Address", CanGrow=true, Style = { BorderStyle = { Bottom = "Solid" }, VerticalAlign = "Middle", TextAlign = "Left", BackgroundColor = "WhiteSmoke", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "3in" });

            customerHeader.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerHeader[3].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "City", Value = "City", Style = { BorderStyle = { Bottom = "Solid" }, VerticalAlign = "Middle", TextAlign = "Left", BackgroundColor = "WhiteSmoke", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.5in" });

            customerHeader.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerHeader[4].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "Phone", Value = "Phone", Style = { BorderStyle = { Bottom = "Solid" }, VerticalAlign = "Middle", TextAlign = "Left", BackgroundColor = "WhiteSmoke", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.1in" });

            #endregion

            #region Table Detail Row

            //Detail Row
            customersTable.Details.TableRows.Clear();
            customersTable.Details.TableRows.Add(new GrapeCity.ActiveReports.PageReportModel.TableRow() { Height = ".3in" });
            var customerDetails = customersTable.Details.TableRows[0].TableCells;
            
            //First cell in the Details row
            customerDetails.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerDetails[0].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "CompanyNameBox",
                Value = "=Fields!CompanyName.Value",                
                Width = "2.35in",                
                Style = { BorderColor = { Bottom = "WhiteSmoke" }, BorderStyle = { Bottom = "Solid" }, TextAlign = "Left", PaddingLeft="3pt", VerticalAlign="Middle"}
            });

            //Second cell in the Details row
            customerDetails.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerDetails[1].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "ContactNameBox",
                Value = "=Fields!ContactName.Value",
                Width = "1.75in",
                Style = { BorderColor = { Bottom = "WhiteSmoke" }, BorderStyle = { Bottom = "Solid" }, TextAlign = "Left", VerticalAlign = "Middle" }
            });

            customerDetails.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerDetails[2].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "AddressBox", Value = "=Fields!Address.Value", Width = "3in", CanGrow=true, Style = { BorderColor = { Bottom = "WhiteSmoke" }, BorderStyle = { Bottom = "Solid" }, TextAlign = "Left", VerticalAlign = "Middle" } });

            customerDetails.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerDetails[3].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "CityBox", Value = "=Fields!City.Value", Width = "1.5in", Style = { BorderColor = { Bottom = "WhiteSmoke" }, BorderStyle = { Bottom = "Solid" }, TextAlign = "Left", VerticalAlign = "Middle" } });

            customerDetails.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerDetails[4].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "PhoneBox", Value = "=Fields!Phone.Value", Width = "1.1in", Style = { BorderColor = { Bottom = "WhiteSmoke" }, BorderStyle = { Bottom = "Solid" }, TextAlign = "Left", VerticalAlign = "Middle" } });
            #endregion

            #region Table Footer

            //Table footer
            customersTable.Footer = new GrapeCity.ActiveReports.PageReportModel.Footer();
            customersTable.Footer.TableRows.Add(new GrapeCity.ActiveReports.PageReportModel.TableRow() { Height = ".5in" });
            var customerFooter = customersTable.Footer.TableRows[0].TableCells;

            //First cell in the footer
            customerFooter.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerFooter[0].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "Company Name",
                Value = "=\"Total Customer Count: \" & CountRows()",
                Style = { 
                    VerticalAlign ="Middle",
                    PaddingLeft="3pt",
                    TextAlign = "Left",
                    FontWeight = "Bold" }
            });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "2.35in" });

            //Second cell in the footer
            customerFooter.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerFooter[1].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox()
            {
                Name = "Contact Name",
                Style = { 
                    VerticalAlign = "Middle",
                    TextAlign = "Left",
                    FontWeight = "Bold" }
            });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.75in" });

            customerFooter.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerFooter[2].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "Address", CanGrow = true, Style = { VerticalAlign = "Middle", TextAlign = "Right", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "2in" });

            customerFooter.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerFooter[3].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "City", Style = { VerticalAlign = "Middle", TextAlign = "Right", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.5in" });

            customerFooter.Add(new GrapeCity.ActiveReports.PageReportModel.TableCell());
            customerFooter[4].ReportItems.Add(new GrapeCity.ActiveReports.PageReportModel.TextBox() { Name = "Phone", Style = { VerticalAlign = "Middle", TextAlign = "Right", FontWeight = "Bold" } });
            customersTable.TableColumns.Add(new GrapeCity.ActiveReports.PageReportModel.TableColumn() { Width = "1.1in" });

            #endregion

            #region Create a parameter 
            //Create a hidden parameter
            GrapeCity.ActiveReports.PageReportModel.ReportParameter selectedCountry = new GrapeCity.ActiveReports.PageReportModel.ReportParameter()
            {
                Name = "selectedCountry",
                Prompt = "Select a country",                
                Hidden = true
            };

            #endregion

            rdlReport.Report.ReportParameters.Add(selectedCountry);
            rdlReport.Report.DataSources.Add(myDataSource());
            rdlReport.Report.DataSets.Add(myDataSet());

            rdlReport.Report.Body.ReportItems.Add(reportTitle);
            rdlReport.Report.Body.ReportItems.Add(customersTable);

            rdlReport.Run();
        }

        private GrapeCity.ActiveReports.PageReportModel.DataSource myDataSource()
        {
            GrapeCity.ActiveReports.PageReportModel.DataSource myDS = new GrapeCity.ActiveReports.PageReportModel.DataSource();
            myDS.Name = "MyDataSource";
            myDS.ConnectionProperties.DataProvider = "JSON";
            myDS.ConnectionProperties.ConnectString = "jsondoc=https://demodata.grapecity.com/northwind/api/v1/Customers";            
            return myDS;
        }

        private GrapeCity.ActiveReports.PageReportModel.IDataSet myDataSet()
        {
            GrapeCity.ActiveReports.PageReportModel.DataSet myDSet = new GrapeCity.ActiveReports.PageReportModel.DataSet();
            GrapeCity.ActiveReports.PageReportModel.Query myQuery = new GrapeCity.ActiveReports.PageReportModel.Query();
            myDSet.Name = "MyDataSet";
            myQuery.DataSourceName = "MyDataSource";
            myQuery.CommandText = "$.[*]";
            myDSet.Query = myQuery;

            //Create individual fields
            GrapeCity.ActiveReports.PageReportModel.Field country = new GrapeCity.ActiveReports.PageReportModel.Field("country", "country", null);
            GrapeCity.ActiveReports.PageReportModel.Field compName = new GrapeCity.ActiveReports.PageReportModel.Field("companyName", "companyName", null);
            GrapeCity.ActiveReports.PageReportModel.Field contactName = new GrapeCity.ActiveReports.PageReportModel.Field("contactName", "contactName", null);
            GrapeCity.ActiveReports.PageReportModel.Field address = new GrapeCity.ActiveReports.PageReportModel.Field("address", "address", null);
            GrapeCity.ActiveReports.PageReportModel.Field cityName = new GrapeCity.ActiveReports.PageReportModel.Field("city", "city", null);
            GrapeCity.ActiveReports.PageReportModel.Field phone = new GrapeCity.ActiveReports.PageReportModel.Field("phone", "phone", null);

            //Create filter to use Parameter
            GrapeCity.ActiveReports.PageReportModel.Filter countryFilter = new GrapeCity.ActiveReports.PageReportModel.Filter
            {
                FilterExpression = "=Fields!country.Value",
                FilterValues = { "=Parameters!selectedCountry.Value" }
            };

            //Add fields and filter to the dataset
            myDSet.Fields.Add(country);
            myDSet.Fields.Add(compName);
            myDSet.Fields.Add(contactName);
            myDSet.Fields.Add(address);
            myDSet.Fields.Add(cityName);
            myDSet.Fields.Add(phone);
            myDSet.Filters.Add(countryFilter);

            return myDSet;
        }
    }
}
